// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from autoware_internal_planning_msgs:srv/SetWaypointRoute.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "autoware_internal_planning_msgs/srv/detail/set_waypoint_route__functions.h"
#include "autoware_internal_planning_msgs/srv/detail/set_waypoint_route__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace autoware_internal_planning_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void SetWaypointRoute_Request_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) autoware_internal_planning_msgs::srv::SetWaypointRoute_Request(_init);
}

void SetWaypointRoute_Request_fini_function(void * message_memory)
{
  auto typed_message = static_cast<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request *>(message_memory);
  typed_message->~SetWaypointRoute_Request();
}

size_t size_function__SetWaypointRoute_Request__waypoints(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<geometry_msgs::msg::Pose> *>(untyped_member);
  return member->size();
}

const void * get_const_function__SetWaypointRoute_Request__waypoints(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<geometry_msgs::msg::Pose> *>(untyped_member);
  return &member[index];
}

void * get_function__SetWaypointRoute_Request__waypoints(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<geometry_msgs::msg::Pose> *>(untyped_member);
  return &member[index];
}

void fetch_function__SetWaypointRoute_Request__waypoints(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const geometry_msgs::msg::Pose *>(
    get_const_function__SetWaypointRoute_Request__waypoints(untyped_member, index));
  auto & value = *reinterpret_cast<geometry_msgs::msg::Pose *>(untyped_value);
  value = item;
}

void assign_function__SetWaypointRoute_Request__waypoints(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<geometry_msgs::msg::Pose *>(
    get_function__SetWaypointRoute_Request__waypoints(untyped_member, index));
  const auto & value = *reinterpret_cast<const geometry_msgs::msg::Pose *>(untyped_value);
  item = value;
}

void resize_function__SetWaypointRoute_Request__waypoints(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<geometry_msgs::msg::Pose> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember SetWaypointRoute_Request_message_member_array[5] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Request, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "goal_pose",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<geometry_msgs::msg::Pose>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Request, goal_pose),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "waypoints",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<geometry_msgs::msg::Pose>(),  // members of sub message
    false,  // is key
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Request, waypoints),  // bytes offset in struct
    nullptr,  // default value
    size_function__SetWaypointRoute_Request__waypoints,  // size() function pointer
    get_const_function__SetWaypointRoute_Request__waypoints,  // get_const(index) function pointer
    get_function__SetWaypointRoute_Request__waypoints,  // get(index) function pointer
    fetch_function__SetWaypointRoute_Request__waypoints,  // fetch(index, &value) function pointer
    assign_function__SetWaypointRoute_Request__waypoints,  // assign(index, value) function pointer
    resize_function__SetWaypointRoute_Request__waypoints  // resize(index) function pointer
  },
  {
    "uuid",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<unique_identifier_msgs::msg::UUID>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Request, uuid),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "allow_modification",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_BOOLEAN,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Request, allow_modification),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers SetWaypointRoute_Request_message_members = {
  "autoware_internal_planning_msgs::srv",  // message namespace
  "SetWaypointRoute_Request",  // message name
  5,  // number of fields
  sizeof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Request),
  false,  // has_any_key_member_
  SetWaypointRoute_Request_message_member_array,  // message members
  SetWaypointRoute_Request_init_function,  // function to initialize message memory (memory has to be allocated)
  SetWaypointRoute_Request_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t SetWaypointRoute_Request_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &SetWaypointRoute_Request_message_members,
  get_message_typesupport_handle_function,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute_Request__get_type_hash,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute_Request__get_type_description,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute_Request__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace autoware_internal_planning_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>()
{
  return &::autoware_internal_planning_msgs::srv::rosidl_typesupport_introspection_cpp::SetWaypointRoute_Request_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, autoware_internal_planning_msgs, srv, SetWaypointRoute_Request)() {
  return &::autoware_internal_planning_msgs::srv::rosidl_typesupport_introspection_cpp::SetWaypointRoute_Request_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "autoware_internal_planning_msgs/srv/detail/set_waypoint_route__functions.h"
// already included above
// #include "autoware_internal_planning_msgs/srv/detail/set_waypoint_route__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace autoware_internal_planning_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void SetWaypointRoute_Response_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) autoware_internal_planning_msgs::srv::SetWaypointRoute_Response(_init);
}

void SetWaypointRoute_Response_fini_function(void * message_memory)
{
  auto typed_message = static_cast<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response *>(message_memory);
  typed_message->~SetWaypointRoute_Response();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember SetWaypointRoute_Response_message_member_array[1] = {
  {
    "status",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<autoware_common_msgs::msg::ResponseStatus>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Response, status),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers SetWaypointRoute_Response_message_members = {
  "autoware_internal_planning_msgs::srv",  // message namespace
  "SetWaypointRoute_Response",  // message name
  1,  // number of fields
  sizeof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Response),
  false,  // has_any_key_member_
  SetWaypointRoute_Response_message_member_array,  // message members
  SetWaypointRoute_Response_init_function,  // function to initialize message memory (memory has to be allocated)
  SetWaypointRoute_Response_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t SetWaypointRoute_Response_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &SetWaypointRoute_Response_message_members,
  get_message_typesupport_handle_function,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute_Response__get_type_hash,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute_Response__get_type_description,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute_Response__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace autoware_internal_planning_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>()
{
  return &::autoware_internal_planning_msgs::srv::rosidl_typesupport_introspection_cpp::SetWaypointRoute_Response_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, autoware_internal_planning_msgs, srv, SetWaypointRoute_Response)() {
  return &::autoware_internal_planning_msgs::srv::rosidl_typesupport_introspection_cpp::SetWaypointRoute_Response_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "array"
// already included above
// #include "cstddef"
// already included above
// #include "string"
// already included above
// #include "vector"
// already included above
// #include "rosidl_runtime_c/message_type_support_struct.h"
// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "autoware_internal_planning_msgs/srv/detail/set_waypoint_route__functions.h"
// already included above
// #include "autoware_internal_planning_msgs/srv/detail/set_waypoint_route__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/field_types.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace autoware_internal_planning_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

void SetWaypointRoute_Event_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) autoware_internal_planning_msgs::srv::SetWaypointRoute_Event(_init);
}

void SetWaypointRoute_Event_fini_function(void * message_memory)
{
  auto typed_message = static_cast<autoware_internal_planning_msgs::srv::SetWaypointRoute_Event *>(message_memory);
  typed_message->~SetWaypointRoute_Event();
}

size_t size_function__SetWaypointRoute_Event__request(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request> *>(untyped_member);
  return member->size();
}

const void * get_const_function__SetWaypointRoute_Event__request(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request> *>(untyped_member);
  return &member[index];
}

void * get_function__SetWaypointRoute_Event__request(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request> *>(untyped_member);
  return &member[index];
}

void fetch_function__SetWaypointRoute_Event__request(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const autoware_internal_planning_msgs::srv::SetWaypointRoute_Request *>(
    get_const_function__SetWaypointRoute_Event__request(untyped_member, index));
  auto & value = *reinterpret_cast<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request *>(untyped_value);
  value = item;
}

void assign_function__SetWaypointRoute_Event__request(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request *>(
    get_function__SetWaypointRoute_Event__request(untyped_member, index));
  const auto & value = *reinterpret_cast<const autoware_internal_planning_msgs::srv::SetWaypointRoute_Request *>(untyped_value);
  item = value;
}

void resize_function__SetWaypointRoute_Event__request(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request> *>(untyped_member);
  member->resize(size);
}

size_t size_function__SetWaypointRoute_Event__response(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response> *>(untyped_member);
  return member->size();
}

const void * get_const_function__SetWaypointRoute_Event__response(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response> *>(untyped_member);
  return &member[index];
}

void * get_function__SetWaypointRoute_Event__response(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response> *>(untyped_member);
  return &member[index];
}

void fetch_function__SetWaypointRoute_Event__response(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const autoware_internal_planning_msgs::srv::SetWaypointRoute_Response *>(
    get_const_function__SetWaypointRoute_Event__response(untyped_member, index));
  auto & value = *reinterpret_cast<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response *>(untyped_value);
  value = item;
}

void assign_function__SetWaypointRoute_Event__response(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response *>(
    get_function__SetWaypointRoute_Event__response(untyped_member, index));
  const auto & value = *reinterpret_cast<const autoware_internal_planning_msgs::srv::SetWaypointRoute_Response *>(untyped_value);
  item = value;
}

void resize_function__SetWaypointRoute_Event__response(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember SetWaypointRoute_Event_message_member_array[3] = {
  {
    "info",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<service_msgs::msg::ServiceEventInfo>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Event, info),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "request",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>(),  // members of sub message
    false,  // is key
    true,  // is array
    1,  // array size
    true,  // is upper bound
    offsetof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Event, request),  // bytes offset in struct
    nullptr,  // default value
    size_function__SetWaypointRoute_Event__request,  // size() function pointer
    get_const_function__SetWaypointRoute_Event__request,  // get_const(index) function pointer
    get_function__SetWaypointRoute_Event__request,  // get(index) function pointer
    fetch_function__SetWaypointRoute_Event__request,  // fetch(index, &value) function pointer
    assign_function__SetWaypointRoute_Event__request,  // assign(index, value) function pointer
    resize_function__SetWaypointRoute_Event__request  // resize(index) function pointer
  },
  {
    "response",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>(),  // members of sub message
    false,  // is key
    true,  // is array
    1,  // array size
    true,  // is upper bound
    offsetof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Event, response),  // bytes offset in struct
    nullptr,  // default value
    size_function__SetWaypointRoute_Event__response,  // size() function pointer
    get_const_function__SetWaypointRoute_Event__response,  // get_const(index) function pointer
    get_function__SetWaypointRoute_Event__response,  // get(index) function pointer
    fetch_function__SetWaypointRoute_Event__response,  // fetch(index, &value) function pointer
    assign_function__SetWaypointRoute_Event__response,  // assign(index, value) function pointer
    resize_function__SetWaypointRoute_Event__response  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers SetWaypointRoute_Event_message_members = {
  "autoware_internal_planning_msgs::srv",  // message namespace
  "SetWaypointRoute_Event",  // message name
  3,  // number of fields
  sizeof(autoware_internal_planning_msgs::srv::SetWaypointRoute_Event),
  false,  // has_any_key_member_
  SetWaypointRoute_Event_message_member_array,  // message members
  SetWaypointRoute_Event_init_function,  // function to initialize message memory (memory has to be allocated)
  SetWaypointRoute_Event_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t SetWaypointRoute_Event_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &SetWaypointRoute_Event_message_members,
  get_message_typesupport_handle_function,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute_Event__get_type_hash,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute_Event__get_type_description,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute_Event__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace autoware_internal_planning_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute_Event>()
{
  return &::autoware_internal_planning_msgs::srv::rosidl_typesupport_introspection_cpp::SetWaypointRoute_Event_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, autoware_internal_planning_msgs, srv, SetWaypointRoute_Event)() {
  return &::autoware_internal_planning_msgs::srv::rosidl_typesupport_introspection_cpp::SetWaypointRoute_Event_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif

// already included above
// #include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_cpp/service_type_support.hpp"
// already included above
// #include "rosidl_typesupport_interface/macros.h"
// already included above
// #include "rosidl_typesupport_introspection_cpp/visibility_control.h"
// already included above
// #include "autoware_internal_planning_msgs/srv/detail/set_waypoint_route__functions.h"
// already included above
// #include "autoware_internal_planning_msgs/srv/detail/set_waypoint_route__struct.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/identifier.hpp"
// already included above
// #include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/service_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/service_type_support_decl.hpp"

namespace autoware_internal_planning_msgs
{

namespace srv
{

namespace rosidl_typesupport_introspection_cpp
{

// this is intentionally not const to allow initialization later to prevent an initialization race
static ::rosidl_typesupport_introspection_cpp::ServiceMembers SetWaypointRoute_service_members = {
  "autoware_internal_planning_msgs::srv",  // service namespace
  "SetWaypointRoute",  // service name
  // the following fields are initialized below on first access
  // see get_service_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute>()
  nullptr,  // request message
  nullptr,  // response message
  nullptr,  // event message
};

static const rosidl_service_type_support_t SetWaypointRoute_service_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &SetWaypointRoute_service_members,
  get_service_typesupport_handle_function,
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>(),
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>(),
  ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute_Event>(),
  &::rosidl_typesupport_cpp::service_create_event_message<autoware_internal_planning_msgs::srv::SetWaypointRoute>,
  &::rosidl_typesupport_cpp::service_destroy_event_message<autoware_internal_planning_msgs::srv::SetWaypointRoute>,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute__get_type_hash,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute__get_type_description,
  &autoware_internal_planning_msgs__srv__SetWaypointRoute__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace srv

}  // namespace autoware_internal_planning_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
get_service_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute>()
{
  // get a handle to the value to be returned
  auto service_type_support =
    &::autoware_internal_planning_msgs::srv::rosidl_typesupport_introspection_cpp::SetWaypointRoute_service_type_support_handle;
  // get a non-const and properly typed version of the data void *
  auto service_members = const_cast<::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
    static_cast<const ::rosidl_typesupport_introspection_cpp::ServiceMembers *>(
      service_type_support->data));
  // make sure all of the service_members are initialized
  // if they are not, initialize them
  if (
    service_members->request_members_ == nullptr ||
    service_members->response_members_ == nullptr ||
    service_members->event_members_ == nullptr)
  {
    // initialize the request_members_ with the static function from the external library
    service_members->request_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::autoware_internal_planning_msgs::srv::SetWaypointRoute_Request
      >()->data
      );
    // initialize the response_members_ with the static function from the external library
    service_members->response_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::autoware_internal_planning_msgs::srv::SetWaypointRoute_Response
      >()->data
      );
    // initialize the event_members_ with the static function from the external library
    service_members->event_members_ = static_cast<
      const ::rosidl_typesupport_introspection_cpp::MessageMembers *
      >(
      ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<
        ::autoware_internal_planning_msgs::srv::SetWaypointRoute_Event
      >()->data
      );
  }
  // finally return the properly initialized service_type_support handle
  return service_type_support;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_service_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__SERVICE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, autoware_internal_planning_msgs, srv, SetWaypointRoute)() {
  return ::rosidl_typesupport_introspection_cpp::get_service_type_support_handle<autoware_internal_planning_msgs::srv::SetWaypointRoute>();
}

#ifdef __cplusplus
}
#endif
