// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from autoware_internal_planning_msgs:msg/VelocityLimitConstraints.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "autoware_internal_planning_msgs/msg/detail/velocity_limit_constraints__functions.h"
#include "autoware_internal_planning_msgs/msg/detail/velocity_limit_constraints__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace autoware_internal_planning_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void VelocityLimitConstraints_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) autoware_internal_planning_msgs::msg::VelocityLimitConstraints(_init);
}

void VelocityLimitConstraints_fini_function(void * message_memory)
{
  auto typed_message = static_cast<autoware_internal_planning_msgs::msg::VelocityLimitConstraints *>(message_memory);
  typed_message->~VelocityLimitConstraints();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember VelocityLimitConstraints_message_member_array[4] = {
  {
    "max_acceleration",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::msg::VelocityLimitConstraints, max_acceleration),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "min_acceleration",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::msg::VelocityLimitConstraints, min_acceleration),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "max_jerk",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::msg::VelocityLimitConstraints, max_jerk),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "min_jerk",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(autoware_internal_planning_msgs::msg::VelocityLimitConstraints, min_jerk),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers VelocityLimitConstraints_message_members = {
  "autoware_internal_planning_msgs::msg",  // message namespace
  "VelocityLimitConstraints",  // message name
  4,  // number of fields
  sizeof(autoware_internal_planning_msgs::msg::VelocityLimitConstraints),
  false,  // has_any_key_member_
  VelocityLimitConstraints_message_member_array,  // message members
  VelocityLimitConstraints_init_function,  // function to initialize message memory (memory has to be allocated)
  VelocityLimitConstraints_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t VelocityLimitConstraints_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &VelocityLimitConstraints_message_members,
  get_message_typesupport_handle_function,
  &autoware_internal_planning_msgs__msg__VelocityLimitConstraints__get_type_hash,
  &autoware_internal_planning_msgs__msg__VelocityLimitConstraints__get_type_description,
  &autoware_internal_planning_msgs__msg__VelocityLimitConstraints__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace autoware_internal_planning_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<autoware_internal_planning_msgs::msg::VelocityLimitConstraints>()
{
  return &::autoware_internal_planning_msgs::msg::rosidl_typesupport_introspection_cpp::VelocityLimitConstraints_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, autoware_internal_planning_msgs, msg, VelocityLimitConstraints)() {
  return &::autoware_internal_planning_msgs::msg::rosidl_typesupport_introspection_cpp::VelocityLimitConstraints_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
